#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct entry {
    char name[30];
    char family[30];
    char number[15];
    struct entry * next;
};

int compare(struct entry * e1, struct entry * e2) {
    int c = strcmp(e1->family, e2->family);
    if (c != 0)
        return c;
    c = strcmp(e1->name, e2->name);
    if (c != 0)
        return c;
    return strcmp(e1->number, e2->number);
}

struct entry * create_node(char name[], char family[], char number[]) {
    struct entry * node = (struct entry *) malloc(sizeof(struct entry));
    if (node == NULL) {
        printf("Cannot allocate memory!\n");
        exit(-1);
    }
    strcpy(node->name, name);
    strcpy(node->family, family);
    strcpy(node->number, number);
    node->next = NULL;
    return node;
}

int add_node(struct entry ** list, struct entry * node) {
    if (*list == NULL) {
        *list = node;
        return 1;
    }
    if (compare(node, *list) < 0) {
        node->next = *list;
        *list = node;
        return 1;
    }
    struct entry * cur = *list, *pre = cur;
    int idx = 1;
    while (cur != NULL) {
        if (compare(node, cur) > 0) {
            idx++;
            pre = cur;
            cur = cur->next;
            continue;
        }
        break;
    }
    node->next = pre->next;
    pre->next = node;
    return idx;
}

void search_list(struct entry * list, char name[], char family[]) {
    int flag = 1;
    while (list != NULL) {
        if ((strcmp(name, "*") == 0 || strstr(list->name, name) != NULL) &&
                (strcmp(family, "*") == 0 || strstr(list->family, family) != NULL)) {
            printf("%s\n", list->number);
            flag = 0;
        }
        list = list->next;
    }
    if (flag) {
        printf("NotFound\n");
    }
}

void delete_number(struct entry ** list, char number[]) {
    int flag = 1, idx = 1;
    struct entry *cur = *list, *pre = cur;
    while (cur != NULL) {
        if (strcmp(cur->number, number) == 0) {
            if (*list == cur) {
                *list = cur->next;
            } else {
                pre->next = cur->next;
            }
            free(cur);
            cur = pre->next;
            printf("de %d\n", idx);
            flag = 0;
        } else {
            pre = cur;
            cur = cur->next;
        }
        idx++;
    }
    if (flag) {
        printf("NotFound\n");
    }
}

void print_node(struct entry *node) {
    printf("%s , %s , %s\n", node->name, node->family, node->number);
};

void print_list(struct entry *list) {
    int idx = 1;
    while (list != NULL) {
        printf("%03d  ", idx++);
        print_node(list);
        list = list->next;
    }
}

int main() {
    int count;
    char str[80], name[30], family[30], number[15];
    struct entry *list = NULL;
    scanf("%d\n", &count);
    printf("%d\n", count);
    for (int i = 0; i < count; ++i) {
        gets(str);
        if (strncmp(str, "Add", 3) == 0) {
            sscanf(str + 4, " %s\t%s\t%s", name, family, number);
            struct entry *node = create_node(name, family, number);
            printf("%d\n", add_node(&list, node));
        } else if (strncmp(str, "Search", 6) == 0) {
            sscanf(str + 7, " %s\t%s", name, family);
            search_list(list, name, family);
        } else if (strncmp(str, "Delete", 6) == 0) {
            sscanf(str + 7, " %s", number);
            delete_number(&list, number);
        }
    }
    print_list(list);
    return 0;
}

